#include "yangencoder/YangAudioEncoderHandle.h"

#include "malloc.h"
#include <unistd.h>
#include <yangavutil/audio/YangMakeWave.h>
#include <yangutil/yangavinfotype.h>
#include "stdlib.h"
#include "yangencoder/YangEncoderFactory.h"

YangAudioEncoderHandle::YangAudioEncoderHandle(YangAudioInfo *pini) {
	m_isInit = 0;
	m_isStart = 0;
	m_isConvert = 1;
	m_in_audioBuffer = NULL;
	m_enc = NULL;
	m_out_audioBuffer = NULL;
	m_ini = pini;
	m_uid=0;

}

YangAudioEncoderHandle::~YangAudioEncoderHandle(void) {
	if (m_isConvert) {
		stop();
		while (m_isStart) {
			usleep(1000);
		}
	}
	yang_delete(m_enc);
	m_ini = NULL;
	m_in_audioBuffer = NULL;
	m_out_audioBuffer = NULL;
}
void YangAudioEncoderHandle::stop() {
	stopLoop();
}

void YangAudioEncoderHandle::run() {
	m_isStart = 1;
	startLoop();
	m_isStart = 0;
}

void YangAudioEncoderHandle::init() {
	if (m_isInit)
		return;
	YangEncoderFactory ydf;
	if (!m_enc)
		m_enc = ydf.createAudioEncoder(m_ini);
	m_enc->init(m_ini);
	m_isInit = 1;

}

void YangAudioEncoderHandle::setInAudioBuffer(YangAudioBuffer *pbuf) {
	m_in_audioBuffer = pbuf;
}
void YangAudioEncoderHandle::setOutAudioBuffer(YangAudioEncoderBuffer *pbuf) {
	m_out_audioBuffer = pbuf;
}

void YangAudioEncoderHandle::onVideoData(YangFrame* pframe) {

}
void YangAudioEncoderHandle::onAudioData(YangFrame* pframe) {

	m_out_audioBuffer->putAudio(pframe);
}
void YangAudioEncoderHandle::startLoop() {
	m_isConvert = 1;
	uint8_t t_buf1[4096];
	yang_reindex(m_in_audioBuffer);
	yang_reindex(m_out_audioBuffer);
	YangFrame audioFrame;

	while (m_isConvert == 1) {
		if (m_in_audioBuffer->m_size == 0) {
			usleep(200);
			continue;
		}
		audioFrame.payload=t_buf1;
		audioFrame.uid=m_uid;
		audioFrame.nb=0;
		if (m_in_audioBuffer->getAudio(&audioFrame)) {
			usleep(1000);
			continue;
		} else {
			m_enc->encoder(&audioFrame, this);

		}
	}			//end

}

void YangAudioEncoderHandle::stopLoop() {
	m_isConvert = 0;

}
